#include <AnsiEscapeCodes.hpp>

std::string mcolor::AnsiEscapeCodes::CursorTo(int line, int column) {
    return AnsiEscapePrefix + std::format("{};{}H", line, column);
}

std::string mcolor::AnsiEscapeCodes::CursorUp(int lines) {
    return AnsiEscapePrefix + std::format("{}A", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorDown(int lines) {
    return AnsiEscapePrefix + std::format("{}B", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorRight(int lines) {
    return AnsiEscapePrefix + std::format("{}D", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorLeft(int lines) {
    return AnsiEscapePrefix + std::format("{}D", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorNextLineStart(int lines) {
    return AnsiEscapePrefix + std::format("{}D", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorPrevLineStart(int lines) {
    return AnsiEscapePrefix + std::format("{}D", lines);
}

std::string mcolor::AnsiEscapeCodes::CursorColumn(int column) {
    return AnsiEscapePrefix + std::format("{}G", column);
}

std::string mcolor::AnsiEscapeCodes::FgTrueColor(int r, int g, int b) {
    return AnsiEscapePrefix + std::format("38;2;{};{};{}m", r, g, b);
}

std::string mcolor::AnsiEscapeCodes::FgTrueColor(const Color4 &c) {
    return FgTrueColor(c.r, c.g, c.b);
}

std::string mcolor::AnsiEscapeCodes::BgTrueColor(int r, int g, int b) {
    return AnsiEscapePrefix + std::format("48;2;{};{};{}m", r, g, b);
}

std::string mcolor::AnsiEscapeCodes::BgTrueColor(const Color4 &c) {
    return BgTrueColor(c.r, c.g, c.b);
}
